import testquals.*;
import checkers.quals.*;

public class DependentTypes {

    // This signature is a type error.  A client of the supertype (SuperQual)
    // can set publicDepSubQual to null, but a client of the subtype cannot.
    public @NonNull @Dependent(result = Nullable.class, when=SuperQual.class) String publicDepSubQual;
    // This signature is a type error.  A client of the supertype need not handle
    // null as a value of publicDepSuperQual, the subtype might contain that.
    // clients of the subtype to do so.
    public @Nullable @Dependent(result = NonNull.class, when=SuperQual.class) String publicDepSuperQual;


    private @NonNull @Dependent(result = Nullable.class, when=SuperQual.class) String privateDepSubQual;
    private @Nullable @Dependent(result = NonNull.class, when=SuperQual.class) String privateDepSuperQual;

    public @NonNull @Dependent(result = Nullable.class, when=SuperQual.class) String getDepSubQual() {
      return privateDepSubQual;
    }
    public @NonNull String getDepSubQualOTHERGOOD() {
      return privateDepSubQual;
    }
    // This signature is a type error.  Clients of the supertype
    // (SuperQual) can pass in null, but clients of the subtype cannot.
    public void setDepSubQualBAD(@NonNull @Dependent(result = Nullable.class, when=SuperQual.class) String s) {
      privateDepSubQual = s;
    }
    public void setDepSubQualGOOD1(@NonNull String s) {
      privateDepSubQual = s;
    }
    public void setDepSubQualGOOD2(@Nullable String s) @SuperQual {
      privateDepSubQual = s;
    }

    // This signature is a type error.  Clients of the supertype need not
    // handle null as a return value, but the subtype may return null.
    public @Nullable @Dependent(result = NonNull.class, when=SuperQual.class) String getDepSuperQualBAD() {
      return privateDepSuperQual;
    }
    public @Nullable String getDepSuperQualGOOD1() {
      return privateDepSuperQual;
    }
    public @NonNull String getDepSuperQualGOOD2() @SuperQual {
      return privateDepSuperQual;
    }
    public void setDepSuperQual(@Nullable @Dependent(result = NonNull.class, when=SuperQual.class) String s) {
      privateDepSuperQual = s;
    }
    public void setDepSuperQualOTHERGOOD(@NonNull String s) @SuperQual {
      privateDepSuperQual = s;
    }
